#!/usr/bin/env bash
#   *** validation ***
scripts/run-validator-tests.sh
scripts/run-checker-tests.sh

#    *** tests ***
mkdir -p tests
echo "Generating test #37"
scripts/gen-input-via-stdout.sh "wine files/gen_with_ans.exe 100 99 100 13 1 4 1 9 -3" "tests/37" 37
echo "Generating test #38"
scripts/gen-input-via-stdout.sh "wine files/gen_with_ans.exe 100 100 100 30 1 15 1 9 7" "tests/38" 38
echo "Generating test #39"
scripts/gen-input-via-stdout.sh "wine files/gen_with_ans.exe 100 97 100 2228 1 2 40 80 9" "tests/39" 39
echo "Generating test #40"
scripts/gen-input-via-stdout.sh "wine files/gen_with_ans.exe 100 89 100 4 1 10 1 2 -3" "tests/40" 40
echo "Generating test #41"
scripts/gen-input-via-stdout.sh "wine files/gen_with_ans.exe 100 100 100 3700 10 20 1 100 12" "tests/41" 41
echo "Generating test #42"
scripts/gen-input-via-stdout.sh "wine files/gen_with_ans.exe 100 100 100 96 5 7 30 70 -1" "tests/42" 42
echo "Generating test #43"
scripts/gen-input-via-stdout.sh "wine files/gen_with_ans.exe 100 100 100 96 5 7 1 2 -1" "tests/43" 43
echo "Generating test #44"
scripts/gen-input-via-stdout.sh "wine files/gen_random.exe 100 100 100 1 100" "tests/44" 44
echo "Generating test #45"
scripts/gen-input-via-stdout.sh "wine files/gen_random.exe 50 100 77 1 100" "tests/45" 45
echo "Generating test #46"
scripts/gen-input-via-stdout.sh "wine files/gen_random.exe 30 94 16 1 100" "tests/46" 46
echo "Generating test #47"
scripts/gen-input-via-stdout.sh "wine files/gen_random.exe 22 79 6 1 100" "tests/47" 47
echo "Generating test #48"
scripts/gen-input-via-stdout.sh "wine files/gen_random.exe 100 100 100 1 4" "tests/48" 48
echo "Generating test #49"
scripts/gen-input-via-stdout.sh "wine files/gen_random.exe 100 100 100 100 100" "tests/49" 49
echo "Generating test #50"
scripts/gen-input-via-stdout.sh "wine files/gen_random.exe 100 100 1 100 100" "tests/50" 50
echo "Generating test #51"
scripts/gen-input-via-stdout.sh "wine files/gen_random.exe 100 100 20 1 1" "tests/51" 51
echo "Generating test #52"
scripts/gen-input-via-stdout.sh "wine files/gen_up_down.exe 100 100 100 40 1 1 10 10 3 6 -3 3" "tests/52" 52
echo "Generating test #53"
scripts/gen-input-via-stdout.sh "wine files/gen_with_ans.exe 100 89 100 4 1 10 1 2 -3 | wine files/fill_trash.exe 77 1 2" "tests/53" 53
echo "Generating test #54"
scripts/gen-input-via-stdout.sh "wine files/gen_random.exe 2400 3000 11 1 3000" "tests/54" 54
echo "Generating test #55"
scripts/gen-input-via-stdout.sh "wine files/gen_random.exe 3000 3000 1 2500 3000" "tests/55" 55
echo "Generating test #56"
scripts/gen-input-via-stdout.sh "wine files/gen_random.exe 3000 3000 2000 1 4" "tests/56" 56
echo "Generating test #57"
scripts/gen-input-via-stdout.sh "wine files/gen_random.exe 3000 3000 3000 3000 3000" "tests/57" 57
echo "Generating test #58"
scripts/gen-input-via-stdout.sh "wine files/gen_random.exe 3000 3000 1 3000 3000" "tests/58" 58
echo "Generating test #59"
scripts/gen-input-via-stdout.sh "wine files/gen_random.exe 3000 3000 3000 1 4" "tests/59" 59
echo "Generating test #60"
scripts/gen-input-via-stdout.sh "wine files/gen_random.exe 1648 1750 100 400 700" "tests/60" 60
echo "Generating test #61"
scripts/gen-input-via-stdout.sh "wine files/gen_random.exe 2547 2645 14 1000 1200" "tests/61" 61
echo "Generating test #62"
scripts/gen-input-via-stdout.sh "wine files/gen_random.exe 444 3000 200 60 70" "tests/62" 62
echo "Generating test #63"
scripts/gen-input-via-stdout.sh "wine files/gen_random.exe 22 2400 1658 600 2400" "tests/63" 63
echo "Generating test #64"
scripts/gen-input-via-stdout.sh "wine files/gen_with_ans.exe 3000 3000 3000 13 1 10 1 4 -3" "tests/64" 64
echo "Generating test #65"
scripts/gen-input-via-stdout.sh "wine files/gen_with_ans.exe 3000 3000 3000 24654 1 1 2500 3000 7" "tests/65" 65
echo "Generating test #66"
scripts/gen-input-via-stdout.sh "wine files/gen_with_ans.exe 3000 3000 3000 546 1 2 1 340 -7" "tests/66" 66
echo "Generating test #67"
scripts/gen-input-via-stdout.sh "wine files/gen_with_ans.exe 3000 3000 3000 600446 1 1 2899 2999 4" "tests/67" 67
echo "Generating test #68"
scripts/gen-input-via-stdout.sh "wine files/gen_with_ans.exe 3000 3000 3000 5869 1 3 1 600 12" "tests/68" 68
echo "Generating test #69"
scripts/gen-input-via-stdout.sh "wine files/gen_with_ans.exe 3000 3000 3000 96 5 7 30 70 -1" "tests/69" 69
echo "Generating test #70"
scripts/gen-input-via-stdout.sh "wine files/gen_with_ans.exe 3000 3000 3000 96 5 7 1 2 -1" "tests/70" 70
echo "Generating test #71"
scripts/gen-input-via-stdout.sh "wine files/gen_with_ans.exe 3000 3000 3000 1800228 1 1 2899 2999 4 | wine files/fill_trash.exe 2456 20 30" "tests/71" 71
echo "Generating test #72"
scripts/gen-input-via-stdout.sh "wine files/gen_with_ans.exe 3000 3000 3000 7869 1 3 1 600 12 | wine files/fill_trash.exe 2745 1 2" "tests/72" 72
echo "Generating test #73"
scripts/gen-input-via-stdout.sh "wine files/gen_with_ans.exe 3000 3000 3000 211 5 7 30 70 -1 | wine files/fill_trash.exe 1566 1 1" "tests/73" 73
echo "Generating test #74"
scripts/gen-input-via-stdout.sh "wine files/gen_with_ans.exe 3000 3000 3000 172 5 7 1 2 -1 | wine files/fill_trash.exe 2222 1 4" "tests/74" 74
echo "Generating test #75"
scripts/gen-input-via-stdout.sh "wine files/gen_up_down.exe 3000 3000 3000 1200 1 2 900 1100 7 900 -3 2" "tests/75" 75
echo "Generating test #76"
scripts/gen-input-via-stdout.sh "wine files/gen_kill_bug1.exe 900 3000 10 5" "tests/76" 76
echo "Generating test #79"
scripts/gen-input-via-stdout.sh "wine files/gen_random.exe 3000 1000000000 3000 1000000000 1000000000" "tests/79" 79
echo "Generating test #80"
scripts/gen-input-via-stdout.sh "wine files/gen_random.exe 3000 1000000000 1 1000000000 1000000000" "tests/80" 80
echo "Generating test #81"
scripts/gen-input-via-stdout.sh "wine files/gen_random.exe 3000 1000000000 3000 1 1000000000" "tests/81" 81
echo "Generating test #83"
scripts/gen-input-via-stdout.sh "wine files/gen_random.exe 3000 1000000000 3000 1 4" "tests/83" 83
echo "Generating test #84"
scripts/gen-input-via-stdout.sh "wine files/gen_random.exe 3000 1000000000 1 900000000 1000000000" "tests/84" 84
echo "Generating test #85"
scripts/gen-input-via-stdout.sh "wine files/gen_random.exe 2798 998546547 3000 1 300000" "tests/85" 85
echo "Generating test #87"
scripts/gen-input-via-stdout.sh "wine files/gen_kill_bug1.exe 2400 1000000000 1022560 15468" "tests/87" 87
echo "Generating test #88"
scripts/gen-input-via-stdout.sh "wine files/gen_with_ans.exe 3000 1000000000 3000 100500 1 100 1 10000 -2" "tests/88" 88
echo "Generating test #89"
scripts/gen-input-via-stdout.sh "wine files/gen_with_ans.exe 3000 1000000000 3000 1228228 30 70 1 100000 -7" "tests/89" 89
echo "Generating test #90"
scripts/gen-input-via-stdout.sh "wine files/gen_with_ans.exe 3000 1000000000 3000 1000658 1 1000 1 100000 -4" "tests/90" 90
echo "Generating test #91"
scripts/gen-input-via-stdout.sh "wine files/gen_with_ans.exe 3000 1000000000 3000 340000000 1 12 1 100000 -4" "tests/91" 91
echo "Generating test #92"
scripts/gen-input-via-stdout.sh "wine files/gen_with_ans.exe 3000 1000000000 3000 1586 1 1000 1 20000 -9" "tests/92" 92
echo "Generating test #93"
scripts/gen-input-via-stdout.sh "wine files/gen_with_ans.exe 3000 1000000000 3000 12548 1 10000 1 100000 -9" "tests/93" 93
echo "Generating test #94"
scripts/gen-input-via-stdout.sh "wine files/gen_with_ans.exe 3000 1000000000 3000 340000000 1 12 1 100000 -4 | wine files/fill_trash.exe 2999 1 20" "tests/94" 94
echo "Generating test #95"
scripts/gen-input-via-stdout.sh "wine files/gen_with_ans.exe 3000 1000000000 3000 1586 1 1000 1 20 -9 | wine files/fill_trash.exe 2998 1 10" "tests/95" 95
echo "Generating test #96"
scripts/gen-input-via-stdout.sh "wine files/gen_with_ans.exe 3000 1000000000 3000 12548 1 10000 1 100 -9 | wine files/fill_trash.exe 2999 1 7" "tests/96" 96
echo "Generating test #97"
scripts/gen-input-via-stdout.sh "wine files/gen_up_down.exe 3000 1000000000 3000 12345 10 20 1300 1300 1 10000 -4 5" "tests/97" 97
echo "Generating test #98"
scripts/gen-input-via-stdout.sh "wine files/gen_precisely.exe 3000 1000000000 3000 432423 1 144 1 10000" "tests/98" 98
echo "Generating test #99"
scripts/gen-input-via-stdout.sh "wine files/gen_precisely.exe 3000 1000000000 3000 1228228 1 144 1 60" "tests/99" 99
echo "Generating test #100"
scripts/gen-input-via-stdout.sh "wine files/gen_precisely.exe 3000 1000000000 3000 1010 1 10000 1 19" "tests/100" 100
echo "Generating test #101"
scripts/gen-input-via-stdout.sh "wine files/gen_precisely.exe 3000 1000000000 3000 10288288 1 4 1 1000000" "tests/101" 101
echo "Generating test #102"
scripts/gen-input-via-stdout.sh "wine files/gen_up_down2.exe 100000 1000000000 1000000000 190006 1 20 95000 95000 1 2 -7 3" "tests/102" 102
echo "Generating test #103"
scripts/gen-input-via-stdout.sh "wine files/gen_random.exe 100000 1000000000 1000000000 1000000000 1000000000" "tests/103" 103
echo "Generating test #104"
scripts/gen-input-via-stdout.sh "wine files/gen_random.exe 100000 1000000000 1 1000000000 1000000000" "tests/104" 104
echo "Generating test #105"
scripts/gen-input-via-stdout.sh "wine files/gen_random.exe 100000 1000000000 1000000000 1 1000000000" "tests/105" 105
echo "Generating test #106"
scripts/gen-input-via-stdout.sh "wine files/gen_random.exe 100000 1000000000 1000000000 1 4" "tests/106" 106
echo "Generating test #107"
scripts/gen-input-via-stdout.sh "wine files/gen_random.exe 98658 700500000 1979 1 40" "tests/107" 107
echo "Generating test #108"
scripts/gen-input-via-stdout.sh "wine files/gen_random.exe 100000 1000000000 11 900000000 1000000000" "tests/108" 108
echo "Generating test #109"
scripts/gen-input-via-stdout.sh "wine files/gen_precisely.exe 100000 1000000000 1000000000 10288288 1 4 1 1000000" "tests/109" 109
echo "Generating test #110"
scripts/gen-input-via-stdout.sh "wine files/gen_random.exe 100000 100000 12343 1 1000000000" "tests/110" 110
echo "Generating test #111"
scripts/gen-input-via-stdout.sh "wine files/gen_random.exe 100000 171000 16 1 1000000000" "tests/111" 111
echo "Generating test #112"
scripts/gen-input-via-stdout.sh "wine files/gen_random.exe 100000 271100 198 10000 29465" "tests/112" 112
echo "Generating test #113"
scripts/gen-input-via-stdout.sh "wine files/gen_random.exe 99858 665417896 1044 96575 100000" "tests/113" 113
echo "Generating test #114"
scripts/gen-input-via-stdout.sh "wine files/gen_random.exe 100000 798456987 10293432 100000000 1000000000" "tests/114" 114
echo "Generating test #115"
scripts/gen-input-via-stdout.sh "wine files/gen_random.exe 97856 989989989 1000500 700000000 1000000000" "tests/115" 115
echo "Generating test #116"
scripts/gen-input-via-stdout.sh "wine files/gen_random.exe 99856 7998889 2281488 700000000 1000000000" "tests/116" 116
echo "Generating test #117"
scripts/gen-input-via-stdout.sh "wine files/gen_precisely.exe 100000 999999999 1000000000 300256 1 2 1 17" "tests/117" 117
echo "Generating test #118"
scripts/gen-input-via-stdout.sh "wine files/gen_kill_bug1.exe 100000 1000000000 200228 5460" "tests/118" 118
echo "Generating test #119"
scripts/gen-input-via-stdout.sh "wine files/gen_kill_bug1.exe 100000 1000000000 200228 80005" "tests/119" 119
echo "Generating test #120"
scripts/gen-input-via-stdout.sh "wine files/gen_kill_bug1.exe 100000 998654312 1002552 647572" "tests/120" 120
echo "Generating test #121"
scripts/gen-input-via-stdout.sh "wine files/gen_with_ans.exe 100000 1000000000 1000000000 1000658 1 1000 1 100000 -4" "tests/121" 121
echo "Generating test #122"
scripts/gen-input-via-stdout.sh "wine files/gen_with_ans.exe 100000 1000000000 1000000000 340000000 1 12 1 100000 -4" "tests/122" 122
echo "Generating test #123"
scripts/gen-input-via-stdout.sh "wine files/gen_with_ans.exe 100000 1000000000 1000000000 1586 1 1000 1 20000 -9" "tests/123" 123
echo "Generating test #124"
scripts/gen-input-via-stdout.sh "wine files/gen_with_ans.exe 100000 1000000000 1000000000 12548 1 10000 1 100000 -9" "tests/124" 124
echo ""
echo "Generating answer for test #1"
scripts/gen-answer.sh tests/01 tests/01.a "tests" "samples"
echo ""
echo "Generating answer for test #2"
scripts/gen-answer.sh tests/02 tests/02.a "tests" "samples"
echo ""
echo "Generating answer for test #3"
scripts/gen-answer.sh tests/03 tests/03.a "tests" "samples"
echo ""
echo "Generating answer for test #4"
scripts/gen-answer.sh tests/04 tests/04.a "tests" "samples"
echo ""
echo "Generating answer for test #5"
scripts/gen-answer.sh tests/05 tests/05.a "tests" "group1"
echo ""
echo "Generating answer for test #6"
scripts/gen-answer.sh tests/06 tests/06.a "tests" "group1"
echo ""
echo "Generating answer for test #7"
scripts/gen-answer.sh tests/07 tests/07.a "tests" "group1"
echo ""
echo "Generating answer for test #8"
scripts/gen-answer.sh tests/08 tests/08.a "tests" "group1"
echo ""
echo "Generating answer for test #9"
scripts/gen-answer.sh tests/09 tests/09.a "tests" "group1"
echo ""
echo "Generating answer for test #10"
scripts/gen-answer.sh tests/10 tests/10.a "tests" "group1"
echo ""
echo "Generating answer for test #11"
scripts/gen-answer.sh tests/11 tests/11.a "tests" "group1"
echo ""
echo "Generating answer for test #12"
scripts/gen-answer.sh tests/12 tests/12.a "tests" "group1"
echo ""
echo "Generating answer for test #13"
scripts/gen-answer.sh tests/13 tests/13.a "tests" "group1"
echo ""
echo "Generating answer for test #14"
scripts/gen-answer.sh tests/14 tests/14.a "tests" "group1"
echo ""
echo "Generating answer for test #15"
scripts/gen-answer.sh tests/15 tests/15.a "tests" "group1"
echo ""
echo "Generating answer for test #16"
scripts/gen-answer.sh tests/16 tests/16.a "tests" "group1"
echo ""
echo "Generating answer for test #17"
scripts/gen-answer.sh tests/17 tests/17.a "tests" "group1"
echo ""
echo "Generating answer for test #18"
scripts/gen-answer.sh tests/18 tests/18.a "tests" "group1"
echo ""
echo "Generating answer for test #19"
scripts/gen-answer.sh tests/19 tests/19.a "tests" "group2"
echo ""
echo "Generating answer for test #20"
scripts/gen-answer.sh tests/20 tests/20.a "tests" "group2"
echo ""
echo "Generating answer for test #21"
scripts/gen-answer.sh tests/21 tests/21.a "tests" "group2"
echo ""
echo "Generating answer for test #22"
scripts/gen-answer.sh tests/22 tests/22.a "tests" "group2"
echo ""
echo "Generating answer for test #23"
scripts/gen-answer.sh tests/23 tests/23.a "tests" "group2"
echo ""
echo "Generating answer for test #24"
scripts/gen-answer.sh tests/24 tests/24.a "tests" "group2"
echo ""
echo "Generating answer for test #25"
scripts/gen-answer.sh tests/25 tests/25.a "tests" "group2"
echo ""
echo "Generating answer for test #26"
scripts/gen-answer.sh tests/26 tests/26.a "tests" "group2"
echo ""
echo "Generating answer for test #27"
scripts/gen-answer.sh tests/27 tests/27.a "tests" "group2"
echo ""
echo "Generating answer for test #28"
scripts/gen-answer.sh tests/28 tests/28.a "tests" "group2"
echo ""
echo "Generating answer for test #29"
scripts/gen-answer.sh tests/29 tests/29.a "tests" "group2"
echo ""
echo "Generating answer for test #30"
scripts/gen-answer.sh tests/30 tests/30.a "tests" "group2"
echo ""
echo "Generating answer for test #31"
scripts/gen-answer.sh tests/31 tests/31.a "tests" "group2"
echo ""
echo "Generating answer for test #32"
scripts/gen-answer.sh tests/32 tests/32.a "tests" "group2"
echo ""
echo "Generating answer for test #33"
scripts/gen-answer.sh tests/33 tests/33.a "tests" "group2"
echo ""
echo "Generating answer for test #34"
scripts/gen-answer.sh tests/34 tests/34.a "tests" "group2"
echo ""
echo "Generating answer for test #35"
scripts/gen-answer.sh tests/35 tests/35.a "tests" "group2"
echo ""
echo "Generating answer for test #36"
scripts/gen-answer.sh tests/36 tests/36.a "tests" "group3"
echo ""
echo "Generating answer for test #37"
scripts/gen-answer.sh tests/37 tests/37.a "tests" "group3"
echo ""
echo "Generating answer for test #38"
scripts/gen-answer.sh tests/38 tests/38.a "tests" "group3"
echo ""
echo "Generating answer for test #39"
scripts/gen-answer.sh tests/39 tests/39.a "tests" "group3"
echo ""
echo "Generating answer for test #40"
scripts/gen-answer.sh tests/40 tests/40.a "tests" "group3"
echo ""
echo "Generating answer for test #41"
scripts/gen-answer.sh tests/41 tests/41.a "tests" "group3"
echo ""
echo "Generating answer for test #42"
scripts/gen-answer.sh tests/42 tests/42.a "tests" "group3"
echo ""
echo "Generating answer for test #43"
scripts/gen-answer.sh tests/43 tests/43.a "tests" "group3"
echo ""
echo "Generating answer for test #44"
scripts/gen-answer.sh tests/44 tests/44.a "tests" "group3"
echo ""
echo "Generating answer for test #45"
scripts/gen-answer.sh tests/45 tests/45.a "tests" "group3"
echo ""
echo "Generating answer for test #46"
scripts/gen-answer.sh tests/46 tests/46.a "tests" "group3"
echo ""
echo "Generating answer for test #47"
scripts/gen-answer.sh tests/47 tests/47.a "tests" "group3"
echo ""
echo "Generating answer for test #48"
scripts/gen-answer.sh tests/48 tests/48.a "tests" "group3"
echo ""
echo "Generating answer for test #49"
scripts/gen-answer.sh tests/49 tests/49.a "tests" "group3"
echo ""
echo "Generating answer for test #50"
scripts/gen-answer.sh tests/50 tests/50.a "tests" "group3"
echo ""
echo "Generating answer for test #51"
scripts/gen-answer.sh tests/51 tests/51.a "tests" "group3"
echo ""
echo "Generating answer for test #52"
scripts/gen-answer.sh tests/52 tests/52.a "tests" "group3"
echo ""
echo "Generating answer for test #53"
scripts/gen-answer.sh tests/53 tests/53.a "tests" "group3"
echo ""
echo "Generating answer for test #54"
scripts/gen-answer.sh tests/54 tests/54.a "tests" "group4"
echo ""
echo "Generating answer for test #55"
scripts/gen-answer.sh tests/55 tests/55.a "tests" "group4"
echo ""
echo "Generating answer for test #56"
scripts/gen-answer.sh tests/56 tests/56.a "tests" "group4"
echo ""
echo "Generating answer for test #57"
scripts/gen-answer.sh tests/57 tests/57.a "tests" "group4"
echo ""
echo "Generating answer for test #58"
scripts/gen-answer.sh tests/58 tests/58.a "tests" "group4"
echo ""
echo "Generating answer for test #59"
scripts/gen-answer.sh tests/59 tests/59.a "tests" "group4"
echo ""
echo "Generating answer for test #60"
scripts/gen-answer.sh tests/60 tests/60.a "tests" "group4"
echo ""
echo "Generating answer for test #61"
scripts/gen-answer.sh tests/61 tests/61.a "tests" "group4"
echo ""
echo "Generating answer for test #62"
scripts/gen-answer.sh tests/62 tests/62.a "tests" "group4"
echo ""
echo "Generating answer for test #63"
scripts/gen-answer.sh tests/63 tests/63.a "tests" "group4"
echo ""
echo "Generating answer for test #64"
scripts/gen-answer.sh tests/64 tests/64.a "tests" "group4"
echo ""
echo "Generating answer for test #65"
scripts/gen-answer.sh tests/65 tests/65.a "tests" "group4"
echo ""
echo "Generating answer for test #66"
scripts/gen-answer.sh tests/66 tests/66.a "tests" "group4"
echo ""
echo "Generating answer for test #67"
scripts/gen-answer.sh tests/67 tests/67.a "tests" "group4"
echo ""
echo "Generating answer for test #68"
scripts/gen-answer.sh tests/68 tests/68.a "tests" "group4"
echo ""
echo "Generating answer for test #69"
scripts/gen-answer.sh tests/69 tests/69.a "tests" "group4"
echo ""
echo "Generating answer for test #70"
scripts/gen-answer.sh tests/70 tests/70.a "tests" "group4"
echo ""
echo "Generating answer for test #71"
scripts/gen-answer.sh tests/71 tests/71.a "tests" "group4"
echo ""
echo "Generating answer for test #72"
scripts/gen-answer.sh tests/72 tests/72.a "tests" "group4"
echo ""
echo "Generating answer for test #73"
scripts/gen-answer.sh tests/73 tests/73.a "tests" "group4"
echo ""
echo "Generating answer for test #74"
scripts/gen-answer.sh tests/74 tests/74.a "tests" "group4"
echo ""
echo "Generating answer for test #75"
scripts/gen-answer.sh tests/75 tests/75.a "tests" "group4"
echo ""
echo "Generating answer for test #76"
scripts/gen-answer.sh tests/76 tests/76.a "tests" "group4"
echo ""
echo "Generating answer for test #77"
scripts/gen-answer.sh tests/77 tests/77.a "tests" "group4"
echo ""
echo "Generating answer for test #78"
scripts/gen-answer.sh tests/78 tests/78.a "tests" "group4"
echo ""
echo "Generating answer for test #79"
scripts/gen-answer.sh tests/79 tests/79.a "tests" "group5"
echo ""
echo "Generating answer for test #80"
scripts/gen-answer.sh tests/80 tests/80.a "tests" "group5"
echo ""
echo "Generating answer for test #81"
scripts/gen-answer.sh tests/81 tests/81.a "tests" "group5"
echo ""
echo "Generating answer for test #82"
scripts/gen-answer.sh tests/82 tests/82.a "tests" "group5"
echo ""
echo "Generating answer for test #83"
scripts/gen-answer.sh tests/83 tests/83.a "tests" "group5"
echo ""
echo "Generating answer for test #84"
scripts/gen-answer.sh tests/84 tests/84.a "tests" "group5"
echo ""
echo "Generating answer for test #85"
scripts/gen-answer.sh tests/85 tests/85.a "tests" "group5"
echo ""
echo "Generating answer for test #86"
scripts/gen-answer.sh tests/86 tests/86.a "tests" "group5"
echo ""
echo "Generating answer for test #87"
scripts/gen-answer.sh tests/87 tests/87.a "tests" "group5"
echo ""
echo "Generating answer for test #88"
scripts/gen-answer.sh tests/88 tests/88.a "tests" "group5"
echo ""
echo "Generating answer for test #89"
scripts/gen-answer.sh tests/89 tests/89.a "tests" "group5"
echo ""
echo "Generating answer for test #90"
scripts/gen-answer.sh tests/90 tests/90.a "tests" "group5"
echo ""
echo "Generating answer for test #91"
scripts/gen-answer.sh tests/91 tests/91.a "tests" "group5"
echo ""
echo "Generating answer for test #92"
scripts/gen-answer.sh tests/92 tests/92.a "tests" "group5"
echo ""
echo "Generating answer for test #93"
scripts/gen-answer.sh tests/93 tests/93.a "tests" "group5"
echo ""
echo "Generating answer for test #94"
scripts/gen-answer.sh tests/94 tests/94.a "tests" "group5"
echo ""
echo "Generating answer for test #95"
scripts/gen-answer.sh tests/95 tests/95.a "tests" "group5"
echo ""
echo "Generating answer for test #96"
scripts/gen-answer.sh tests/96 tests/96.a "tests" "group5"
echo ""
echo "Generating answer for test #97"
scripts/gen-answer.sh tests/97 tests/97.a "tests" "group5"
echo ""
echo "Generating answer for test #98"
scripts/gen-answer.sh tests/98 tests/98.a "tests" "group5"
echo ""
echo "Generating answer for test #99"
scripts/gen-answer.sh tests/99 tests/99.a "tests" "group5"
echo ""
echo "Generating answer for test #100"
scripts/gen-answer.sh tests/100 tests/100.a "tests" "group5"
echo ""
echo "Generating answer for test #101"
scripts/gen-answer.sh tests/101 tests/101.a "tests" "group5"
echo ""
echo "Generating answer for test #102"
scripts/gen-answer.sh tests/102 tests/102.a "tests" "group6"
echo ""
echo "Generating answer for test #103"
scripts/gen-answer.sh tests/103 tests/103.a "tests" "group6"
echo ""
echo "Generating answer for test #104"
scripts/gen-answer.sh tests/104 tests/104.a "tests" "group6"
echo ""
echo "Generating answer for test #105"
scripts/gen-answer.sh tests/105 tests/105.a "tests" "group6"
echo ""
echo "Generating answer for test #106"
scripts/gen-answer.sh tests/106 tests/106.a "tests" "group6"
echo ""
echo "Generating answer for test #107"
scripts/gen-answer.sh tests/107 tests/107.a "tests" "group6"
echo ""
echo "Generating answer for test #108"
scripts/gen-answer.sh tests/108 tests/108.a "tests" "group6"
echo ""
echo "Generating answer for test #109"
scripts/gen-answer.sh tests/109 tests/109.a "tests" "group6"
echo ""
echo "Generating answer for test #110"
scripts/gen-answer.sh tests/110 tests/110.a "tests" "group6"
echo ""
echo "Generating answer for test #111"
scripts/gen-answer.sh tests/111 tests/111.a "tests" "group6"
echo ""
echo "Generating answer for test #112"
scripts/gen-answer.sh tests/112 tests/112.a "tests" "group6"
echo ""
echo "Generating answer for test #113"
scripts/gen-answer.sh tests/113 tests/113.a "tests" "group6"
echo ""
echo "Generating answer for test #114"
scripts/gen-answer.sh tests/114 tests/114.a "tests" "group6"
echo ""
echo "Generating answer for test #115"
scripts/gen-answer.sh tests/115 tests/115.a "tests" "group6"
echo ""
echo "Generating answer for test #116"
scripts/gen-answer.sh tests/116 tests/116.a "tests" "group6"
echo ""
echo "Generating answer for test #117"
scripts/gen-answer.sh tests/117 tests/117.a "tests" "group6"
echo ""
echo "Generating answer for test #118"
scripts/gen-answer.sh tests/118 tests/118.a "tests" "group6"
echo ""
echo "Generating answer for test #119"
scripts/gen-answer.sh tests/119 tests/119.a "tests" "group6"
echo ""
echo "Generating answer for test #120"
scripts/gen-answer.sh tests/120 tests/120.a "tests" "group6"
echo ""
echo "Generating answer for test #121"
scripts/gen-answer.sh tests/121 tests/121.a "tests" "group6"
echo ""
echo "Generating answer for test #122"
scripts/gen-answer.sh tests/122 tests/122.a "tests" "group6"
echo ""
echo "Generating answer for test #123"
scripts/gen-answer.sh tests/123 tests/123.a "tests" "group6"
echo ""
echo "Generating answer for test #124"
scripts/gen-answer.sh tests/124 tests/124.a "tests" "group6"
echo ""

