#include "testlib.h"
#include <stdio.h>
#include <iostream>
#include <stdlib.h>
#include <string>
#include <string.h>
#include <vector>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <map>
#include <assert.h>
#include <algorithm>
#include <iomanip>
#include <time.h>
#include <math.h>
#include <bitset>

#pragma comment(linker, "/STACK:256000000")

using namespace std;

typedef long long int ll;
typedef long double ld;

set<pair<int, int>> used;
set<pair<int, int>> have;

bool check_in(int x)
{
	if (used.empty())
	{
		return false;
	}
	else
	{
		auto it = used.upper_bound({x + 1, -1});

		if (it == used.begin())
		{
			return false;
		}
		else
		{
			--it;

			return it->first <= x && x <= it->second; 
		}
	}
}

vector<int> next(int x, int h)
{
	auto it = --used.upper_bound({x + 1, -1});
	
	vector<int> ans;
	
	if (it->second + 1 <= h)
	{
		ans.push_back(it->second + 1);
	}
	if (it->first - 1 > 0)
	{
		ans.push_back(it->first - 1);
	}

	return ans;
}

void insert(int x)
{
	if (used.empty())
	{
		used.insert({x, x});
	}
	else
	{
		auto it = used.upper_bound({x + 1, -1});
	

		if (it == used.begin())
		{
			if (x + 1 == it->first)
			{
				pair<int, int> mem = *it;
				used.erase(it);
				--mem.first;
				used.insert(mem);
			}
			else
			{
				used.insert({x, x});
			}
		}
		else if (it == used.end())
		{
			--it;
			if (it->second == x - 1)
			{
				pair<int, int> mem = *it;
				used.erase(it);
				++mem.second;
				used.insert(mem);
			}
			else
			{
				used.insert({x, x});
			}
		}
		else
		{
			auto itr = it;
			auto itl = --it;

			if (itl->second == x - 1 && x + 1 == itr->first)
			{
				pair<int, int> meml = *itl;
				pair<int, int> memr = *itr;
				used.erase(meml);
				used.erase(memr);
				used.insert({meml.first, memr.second});
			}
			else if (itl->second == x - 1)
			{
				pair<int, int> mem = *itl;
				used.erase(itl);
				++mem.second;
				used.insert(mem);
			}
			else if (x + 1 == itr->first)
			{
				pair<int, int> mem = *itr;
				used.erase(itr);
				--mem.first;
				used.insert(mem);
			}
			else
			{
				used.insert({x, x});
			}
		}
	}
}

int main(int argc, char **argv)
{
	registerGen(argc, argv, 1);
	int max_n = atoi(argv[1]);
	int h = atoi(argv[2]);
	int max_t = atoi(argv[3]);
	int ans = atoi(argv[4]);
	int min_step = atoi(argv[5]);
	int max_step = atoi(argv[6]);
	int min_now = atoi(argv[7]);
	int max_now = atoi(argv[8]);
	int min_v = atoi(argv[9]);
	int max_v = atoi(argv[10]);
	int tp = atoi(argv[11]);
	int on_it = atoi(argv[12]);

	int n = 0;	
	ll t = 1;
	ll ptr = 0;
	
	int it = 0;	
	while (ptr < h && n < max_n && t < max_t)
	{
		++it;
		ll next = min((ll)rnd.next(min_step, max_step), (h - ptr + ans - 1) / ans);
		t += next;
		int on_now = min(rnd.next(min_now, max_now), max_n - n);
		
		if (it != on_it && on_it != -1)
			on_now = 0;

		ll range_start = ptr;
		ptr += ans * next;
		
		for (int i = 0; i < on_now; ++i)
		{
			ll new_at = min(rnd.next(min(range_start, ptr - 1), ptr), (ll)h);
			ll new_val = min(rnd.next(2, 2), ans - 1);
			if (new_at > 0 && new_val > 0 && !check_in(new_at))
			{
				++n;
				have.insert({new_at, new_val});
				ans -= new_val;
				ptr = max(new_at - 1, ptr - new_at);
				insert(new_at);
			}
		}

		for (int i = 0; n < max_n && (ptr >= h || i == 0) && i < 6; ++i)
		{
			ll new_at = rnd.next(ptr - ans, min(ptr, (ll)h));
			ll new_val = min(rnd.wnext(min_v, max_v, tp), ans - 1);
			if (new_at > 0 && new_val > 0 && !check_in(new_at))
			{
				++n;
				have.insert({new_at,  new_val});
				ans -= new_val;
				ptr = max(new_at - 1, ptr - new_val);
				insert(new_at);
			}
		}
		for (int i = 0; n < max_n && ptr >= h && i < 11; ++i)
		{
			ll new_at = min(rnd.next(1ll, max(1ll, ptr)), (ll)h);
			ll new_val = min(rnd.wnext(min_v, max_v, tp), ans - 1);
			if (new_at > 0 && new_val > 0 && !check_in(new_at))
			{
				++n;
				have.insert({new_at,  new_val});
				ans -= new_val;
				ptr = max(new_at - 1, ptr - new_val);
				insert(new_at);
			}
		}
	}
	
	t += max(0ll, h - ptr) / ans;
	t = min(t, (ll)max_t);
	
	printf("%d %d %lld\n", n, h, t);
	for (auto it = have.begin(); it != have.end(); ++it)
	{
		printf("%d %d\n", it->first, it->second);
	}

	return 0;
}


