#include <stdio.h>
#include <iostream>
#include <stdlib.h>
#include <string>
#include <string.h>
#include <vector>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <map>
#include <assert.h>
#include <algorithm>
#include <iomanip>
#include <time.h>
#include <math.h>
#include <bitset>

#pragma comment(linker, "/STACK:256000000")

using namespace std;

typedef long long int ll;
typedef long double ld;

const int INF = 1000 * 1000 * 1000 + 21;
const ll LLINF = (1ll << 60) + 5;
const int MOD = 1000 * 1000 * 1000 + 7;

const int MAX_N = 1000 * 100 + 5;

struct hole
{
	ll h;
	ll v;
};

int n;
ll h, t;
hole arr[MAX_N]; 
ll holes[MAX_N];
ll sums[MAX_N];
ll sum = 0;
vector<pair<ll, ll>> go_down;
set<pair<ll, ll>> fd_go_down;

ll get(int l, int r)
{
	if (l > r) return 0ll;
	return sums[r] - sums[l - 1];
}

void calc()
{
	ll last = -1;
	ll next_go_down = -1;
	for (int i = 0; i < n; ++i)
	{
		if (arr[i].h > next_go_down)
		{
			if (arr[i].h - 1 == next_go_down)
			{
				next_go_down += arr[i].v;
			}
			else
			{
				if (last != -1)
				{
					go_down.push_back({last, next_go_down});
				}
				last = arr[i].h;
				next_go_down = arr[i].h + arr[i].v - 1;
			}
		}
		else
		{
			next_go_down += arr[i].v;
		}
	}

	if (last != -1)
	{
		go_down.push_back({last, next_go_down});
	}

	for (int i = 0; i < (int)go_down.size(); ++i)
	{
		fd_go_down.insert({go_down[i].second, go_down[i].first});
	}
}

ll get_go(ll x)
{
	auto it = fd_go_down.lower_bound({x, -1ll});

	if (it != fd_go_down.end() && it->second <= x && x <= it->first)
	{
		x = it->second - 1;
	}

	int ptr = upper_bound(holes, holes + n, x) - holes;

	x -= get(1, ptr);

	return x;
}

bool check(ll m)
{
	ll h_now = 0;
	ll t_now = 0;
	while (h_now < h)
	{
		++t_now;
		h_now += m;
		h_now = get_go(h_now);

		int ptr = upper_bound(holes, holes + n, h_now) - holes;

		if (ptr == n)
		{
			ll diff = max(0ll, h - h_now);
			ll to_add = (diff + m - sum - 1) / (m - sum);
			t_now += to_add;
			h_now += to_add * (m - sum);
		}
		else
		{
			ll right = h_now + m;
			ptr = upper_bound(holes, holes + n, right) - holes;
			ll target = (ptr == n) ? h : arr[ptr].h;
			ll diff = max(0ll, target - right - 1);
			
			if (ptr == n)
			{
				diff = max(0ll, h - h_now + m - get(1, ptr) - 1);
			}
			ll to_add = (diff) / (m - get(1, ptr));
			
			t_now += to_add;
			h_now += to_add * (m - get(1, ptr));
		}
	}
	
	return t_now <= t;
}

int main()
{
#ifdef CH_EGOR
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	//freopen("", "r", stdin);
	//freopen("", "w", stdout);
#endif

	scanf("%d%lld%lld", &n, &h, &t);

	for (int i = 0; i < n; ++i)
	{
		scanf("%lld%lld", &arr[i].h, &arr[i].v);
		sum += arr[i].v;
		sums[i + 1] = sums[i] + arr[i].v;
		holes[i] = arr[i].h;
	}
	
	calc();

	ll l = sum;
	ll r = sum + h; // fill in one second

	while (r - l > 1)
	{
		ll m = (l + r) >> 1;

		if (check(m))
			r = m;
		else
			l = m;
	}

	printf("%lld\n", r);

	return 0;
}

