#include "testlib.h"
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <algorithm>
#include <cstring>
#include <string>
#include <cmath>
#include <cassert>
#include <ctime>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>

using namespace std;

#define pb push_back
#define mp make_pair
#define fs first
#define sc second

int main(int argc, char ** argv) {
	registerGen(argc, argv, 1);
	if (argc != 9) {
		cerr << "usage: a, b, m, a_deg, qs, maxc, prob, seed" << endl;

		return 1;
	}
	int a = atoi(argv[1]);
	int b = atoi(argv[2]);
	int m = atoi(argv[3]);
	int deg = atoi(argv[4]);
	int q = atoi(argv[5]);
	int c = atoi(argv[6]);
	int p = atoi(argv[7]);
	int n = a + b;

	printf("%d %d\n", n, m);

	vector <int> d(n);
	map <pair <int, int>, int> edges;
	while ((int) edges.size() < m) {
		int u = rnd.next(0, a - 1);
		int v = rnd.next(a, n - 1);
		if (d[u] == deg || d[v] == deg)
			continue;
		if (edges.count(mp(u, v)) == 0) {
			d[u]++, d[v]++;
		}
		edges[mp(u, v)] = rnd.next(c / 2, c);
	}

	for (auto& e : edges) {
		printf("%d %d %d\n", e.fs.fs + 1, e.fs.sc + 1, e.sc);
	}
	printf("%d\n", q);
    for (int i = 0; i < q; i++) {
    	if (rnd.next(1, 100) <= p) {
    		int u = 0, v = 0;
    		while (u == v) {
				u = rnd.next(0, a - 1);
				v = rnd.next(0, a - 1);    		
    		}
    		printf("3 %d %d\n", u + 1, v + 1);
    	} else {
    		int cur = (int) edges.size();
    		int u = -1, v = -1, cost = -1;
    		while ((int) edges.size() == cur) {
    			u = rnd.next(0, a - 1);
    			v = rnd.next(a, n - 1);
    			if (d[u] == deg || d[v] == deg)
    				continue;
    			cost = rnd.next(1, c / 2);
				if (edges.count(mp(u, v)) == 0) {
					d[u]++, d[v]++;
				}

    			edges[mp(u, v)] = cost;
    		}
    		printf("1 %d %d %d\n", u + 1, v + 1, cost);
    	}
    }

    return 0;
}