#include "testlib.h"
#include "ak-testlib.h"
#include <bits/stdc++.h>

using namespace std;

int deg[1000 * 1000];

int main(int argc, char **argv)
{
	assert(argc == 1 + 6 + 1); // path + type n m q deg first + random
	registerGen(argc, argv, 1);
	int type = stoi(argv[1]);
	int n = stoi(argv[2]);
	int m = stoi(argv[3]);
	int q = stoi(argv[4]);
	int d = stoi(argv[5]);
	int s = stoi(argv[6]);
	
	if(type == 1) // random
	{
		cout << n << " " << m << endl;
		set<pair<int, int>> st;
		for(int i = 0; i < m; ++i)
		{
			auto p = gen_edge(n);
			if(st.count({min(p.x, p.y), max(p.x, p.y)}) || deg[p.x] == d || deg[p.y] == d)
			{
				--i;
				continue;
			}
			
			++deg[p.x];
			++deg[p.y];
			st.insert({min(p.x, p.y), max(p.x, p.y)});
			cout << p.x << " " << p.y << " " << rnd.next(0, 1000000000) << endl;
		}
		cout << q << endl;
		for(int i = 0; i < q; ++i)
		{
			int t = rnd.next(1, 3);
			
			if(t == 1)
			{
				auto p = gen_edge(n);
				while(st.count({min(p.x, p.y), max(p.x, p.y)}) || deg[p.x] == d || deg[p.y] == d)
				{
					p = gen_edge(n);
				}
				++deg[p.x];
			    ++deg[p.y];
				st.insert({min(p.x, p.y), max(p.x, p.y)});
				cout << t << " " << p.x << " " << p.y << " " << rnd.next(0, 1000000000) << endl;
			}
			else if(t == 2)
			{
				if(st.empty())
				{
					--i;
					continue;
				}
				auto it = st.lower_bound({rnd.next(1, n), rnd.next(1, n)});
				if(it == st.end())
				{
					--it;
				}
				--deg[it->x];
				--deg[it->y];
				cout << t << " " << it->x << " " << it->y << endl;
				st.erase(it);
			}
			else
			{
				auto p = gen_edge(n);
				cout << t << " " << p.x << " " << p.y << endl;
			}
		}
	}
	else if(type == 2) // almost bipartile
	{
	    cout << n << " " << m << endl;
		set<pair<int, int>> st;
		for(int i = 0; i < m; ++i)
		{
			pair<int, int> p;
			p.x = rnd.next(1, s);
			p.y = rnd.next(s + 1, n);
			if(rnd.next(1, 10) == 1)
			{
				p = gen_edge(n);
			}
			if(st.count({min(p.x, p.y), max(p.x, p.y)}) || deg[p.x] == d || deg[p.y] == d)
			{
				--i;
				continue;
			}
			
			++deg[p.x];
			++deg[p.y];
			st.insert({min(p.x, p.y), max(p.x, p.y)});
			cout << p.x << " " << p.y << " " << rnd.next(0, 1000000000) << endl;
		}
		cout << q << endl;
		for(int i = 0; i < q; ++i)
		{
			int t = rnd.next(1, 3);
			
			if(t == 1)
			{
				pair<int, int> p;
				p.x = rnd.next(1, s);
			    p.y = rnd.next(s + 1, n);
			    if(rnd.next(1, 10) == 1)
				{
				    p = gen_edge(n);
				}
				while(st.count({min(p.x, p.y), max(p.x, p.y)}) || deg[p.x] == d || deg[p.y] == d)
				{
				    p.x = rnd.next(1, s);
			        p.y = rnd.next(s + 1, n);
				}
				++deg[p.x];
			    ++deg[p.y];
				st.insert({min(p.x, p.y), max(p.x, p.y)});
				cout << t << " " << p.x << " " << p.y << " " << rnd.next(0, 1000000000) << endl;
			}
			else if(t == 2)
			{
				if(st.empty())
				{
					--i;
					continue;
				}
				auto it = st.lower_bound({rnd.next(1, n), rnd.next(1, n)});
				if(it == st.end())
				{
					--it;
				}
				--deg[it->x];
				--deg[it->y];
				cout << t << " " << it->x << " " << it->y << endl;
				st.erase(it);
			}
			else
			{
				pair<int, int> p;
				if(rnd.next(1, 3) == 1)
				{
				    p.x = rnd.next(1, s);
				    p.y = rnd.next(1, s);
				    while(p.x == p.y)
				    {
				        p.y = rnd.next(1, s);
				    }
				}
				else if(rnd.next(2, 3) == 2)
				{
				    p.x = rnd.next(1, s);
				    p.y = rnd.next(s + 1, n);
				}
				else
				{
                    p.x = rnd.next(s + 1, n);
				    p.y = rnd.next(s + 1, n);
				    while(p.x == p.y)
				    {
				        p.y = rnd.next(s + 1, n);
				    }
				}
				cout << t << " " << p.x << " " << p.y << endl;
			}
		}
	}
}

