#include "testlib.h"
#include <bits/stdc++.h>

using namespace std;

const int MAX_N[] = {100, 100, 3000, 100 * 1000, 100 * 1000};
const int MAX_M[] = {100, 100, 3000, 100 * 1000, 100 * 1000};
const int MAX_Q[] = {100, 100, 3000, 100 * 1000, 100 * 1000};
const int MAX_D[] = {100, 100, 3000, 500,        100 * 1000};
const int MAX_C = 1000 * 1000 * 1000;
int deg[1000 * 1000];

int main(int argc, char **argv) 
{
    registerValidation(argc, argv);
    
    int group;
    if(validator.group().empty())
    {
        group = 0;
    }
    else
    {
        group = stoi(validator.group());
    }
    
    int n = inf.readInt(2, MAX_N[group], "n");
    inf.readSpace();
    int m = inf.readInt(0, MAX_M[group], "m");
    inf.readEoln();
    
    set<pair<int, int>> st;
    
    for(int i = 0; i < m; ++i)
    {
		int a = inf.readInt(1, n, "a_i");
		inf.readSpace();
		int b = inf.readInt(1, n, "b_i");
		inf.readSpace();
		inf.readInt(0, MAX_C, "c_i");
		inf.readEoln();
		
		if(a > b)
		{
		    swap(a, b);
		}
		
		ensuref(a != b, "a loop");
		ensuref(st.count({a, b}) == 0, "already has this edge");
		st.insert({a, b});
		++deg[a];
		++deg[b];
		ensuref(deg[a] <= MAX_D[group], "degree");
		ensuref(deg[b] <= MAX_D[group], "degree");
	}
	
	int q = inf.readInt(1, MAX_Q[group], "q");
	inf.readEoln();
	
	bool flag = false;
	
	for(int i = 0; i < q; ++i)
	{
		int t = inf.readInt(1, 3, "t_i");
		if (t == 3)
		    flag = true;
		inf.readSpace();
		int a = inf.readInt(1, n, "a_i");
		inf.readSpace();
		int b = inf.readInt(1, n, "b_i");
		ensuref(a != b, "a loop");
		if(a > b)
		{
			swap(a, b);
		}
		
		if(t == 1)
		{
		    ++deg[a];
		    ++deg[b];
		    ensuref(deg[a] <= MAX_D[group], "degree");
		    ensuref(deg[b] <= MAX_D[group], "degree");
			ensuref(st.count({a, b}) == 0, "already has this edge");
			inf.readSpace();
			inf.readInt(0, MAX_C, "c_i");
			st.insert({a, b});
		}
		else if(t == 2)
		{
		    --deg[a];
		    --deg[b];
			ensuref(st.count({a, b}) == 1, "no such edge");
			st.erase({a, b});
		}
		
		inf.readEoln();
	}
	
	ensuref(flag, "output should be non-empty, i.e. at least one query of type 3 expected");
	inf.readEof();
    return 0;
}

