/*
* C++11 code template for contests.
* @author: Andrei Kalendarov
* @e-mail: andreykalendarov@gmail.com
*/

#ifndef ANDREIKKAA
#pragma GCC optimize ("O3")
#endif
//#define ANDREIKKAA_ALLOCATOR
//#define ANDREIKKAA_INTERACTIVE
const int _ML = 500;
const char _inpf[] =
#ifdef ANDREIKKAA
        "input.txt"
#else
""
#endif
;
const char _outf[] =
#ifdef ANDREIKKAA
        ""
#else
""
#endif
;

#include <bits/stdc++.h>
using namespace std;
#define x first
#define y second
#define rand rd
#define random_shuffle abcdefghijklmnopqrstuvwxyz
#if !defined(ANDREIKKAA_INTERACTIVE) && !defined(ANDREIKKAA)
#define endl '\n'
#endif
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x).size()
typedef long long ll;
typedef double ld;
const ld PI = 3.14159265358979323846;
mt19937 rd(228);

#if defined(ANDREIKKAA_ALLOCATOR)
char _mem[_ML * 1024 * 1024];
size_t _ptr = 0;
inline void* operator new (size_t _x) { _ptr += _x; return _mem + _ptr - _x; }
inline void operator delete (void*) { }
#endif

template<typename T, typename U> inline ostream &operator<< (ostream &_out, const pair<T, U> &_p) { _out << _p.first << ' ' << _p.second; return _out; }
template<typename T, typename U> inline istream &operator>> (istream &_in, pair<T, U> &_p) { _in >> _p.first >> _p.second; return _in; }
template<typename T> inline ostream &operator<< (ostream &_out, const vector<T> &_v) { if (_v.empty()) { return _out; } _out << _v.front(); for (auto _it = ++_v.begin(); _it != _v.end(); ++_it) { _out << ' ' << *_it; } return _out; }
template<typename T> inline istream &operator>> (istream &_in, vector<T> &_v) { for (auto &_i : _v) { _in >> _i; } return _in; }
template<typename T> inline ostream &operator<< (ostream &_out, const set<T> &_s) { if (_s.empty()) { return _out; } _out << *_s.begin(); for (auto _it = ++_s.begin(); _it != _s.end(); ++_it) { _out << ' ' << *_it; } return _out; }
template<typename T> inline ostream &operator<< (ostream &_out, const multiset<T> &_s) { if (_s.empty()) { return _out; } _out << *_s.begin(); for (auto _it = ++_s.begin(); _it != _s.end(); ++_it) { _out << ' ' << *_it; } return _out; }
template<typename T> inline ostream &operator<< (ostream &_out, const unordered_set<T> &_s) { if (_s.empty()) { return _out; } _out << *_s.begin(); for (auto _it = ++_s.begin(); _it != _s.end(); ++_it) { _out << ' ' << *_it; } return _out; }
template<typename T> inline ostream &operator<< (ostream &_out, const unordered_multiset<T> &_s) { if (_s.empty()) { return _out; } _out << *_s.begin(); for (auto _it = ++_s.begin(); _it != _s.end(); ++_it) { _out << ' ' << *_it; } return _out; }
template<typename T, typename U> inline ostream &operator<< (ostream &_out, const map<T, U> &_m) { if (_m.empty()) { return _out; } _out << '(' << _m.begin()->first << ": " << _m.begin()->second << ')'; for (auto _it = ++_m.begin(); _it != _m.end(); ++_it) { _out << ", (" << _it->first << ": " << _it->second << ')'; } return _out; }
template<typename T, typename U> inline ostream &operator<< (ostream &_out, const unordered_map<T, U> &_m) { if (_m.empty()) { return _out; } _out << '(' << _m.begin()->first << ": " << _m.begin()->second << ')'; for (auto _it = ++_m.begin(); _it != _m.end(); ++_it) { _out << ", (" << _it->first << ": " << _it->second << ')'; } return _out; }

/* ________ CODE ________ */

const int N = 100 * 1000 + 2;
const int M = 100 * 1000 + 2;
const int Q = 100 * 1000 + 2;
const int FAT = 150;

struct
{
    int t, a, b, c;
} qu[Q];

struct
{
    int a, b, c;
} ed[M];

set<pair<int, int>> g[N];
int deg[N];
bool fat[N];
vector<int> fats;
int num[N];

multiset<int> fatfat[2 * N / FAT + 1][2 * N / FAT + 1];
int gfat[2 * N / FAT + 1][2 * N / FAT + 1];

int ask_path(int a, int b)
{
    if(!fat[a] || !fat[b])
    {
        if(fat[a])
        {
            swap(a, b);
        }

        int ans = INT_MAX;
        for(auto i : g[a])
        {
            if(i.x == b)
            {
                ans = min(ans, i.y);
            }
            auto it = g[i.x].lower_bound({b, -1});
            if(it != g[i.x].end() && it->x == b)
            {
                ans = min(ans, it->y + i.y);
            }
        }

        if(ans == INT_MAX)
        {
            ans = -1;
        }
        return ans;
    }

    a = num[a];
    b = num[b];
    if(a > b)
    {
        swap(a, b);
    }

    int ans = INT_MAX;
    if(gfat[a][b] != -1)
    {
        ans = gfat[a][b];
    }

    for(int i : fats)
    {
        if(gfat[a][num[i]] != -1 && gfat[num[i]][b] != -1)
        {
            ans = min(ans, gfat[a][num[i]] + gfat[num[i]][b]);
        }
    }

    if(!fatfat[a][b].empty())
    {
        ans = min(ans, *fatfat[a][b].begin());
    }

    if(ans == INT_MAX)
    {
        ans = -1;
    }
    return ans;
}

void rem_edge(int a, int b)
{
    int c = g[a].lower_bound({b, -1})->y;
    g[a].erase(g[a].lower_bound({b, -1}));
    g[b].erase(g[b].lower_bound({a, -1}));

    if(fat[a] ^ fat[b])
    {
        if(fat[a])
        {
            swap(a, b);
        }

        for(auto i : g[a])
        {
            if(fat[i.x])
            {
                int n1 = num[i.x];
                int n2 = num[b];
                if(n1 > n2)
                {
                    swap(n1, n2);
                }

                fatfat[n1][n2].erase(fatfat[n1][n2].find(c + i.y));
            }
        }
    }
    else if(fat[a] && fat[b])
    {
        gfat[num[a]][num[b]] = gfat[num[b]][num[a]] = -1;
    }
}

void add_edge(int a, int b, int c)
{
    if(fat[a] ^ fat[b])
    {
        if(fat[a])
        {
            swap(a, b);
        }

        for(auto i : g[a])
        {
            if(fat[i.x])
            {
                int n1 = num[i.x];
                int n2 = num[b];
                if(n1 > n2)
                {
                    swap(n1, n2);
                }

                fatfat[n1][n2].insert(i.y + c);
            }
        }
    }
    else if(fat[a] && fat[b])
    {
        gfat[num[a]][num[b]] = gfat[num[b]][num[a]] = c;
    }

    g[a].insert({b, c});
    g[b].insert({a, c});
}

inline void mainFunction()
{
    int n, m;
    cin >> n >> m;

    for(int i = 0; i < m; ++i)
    {
        cin >> ed[i].a >> ed[i].b >> ed[i].c;
        ++deg[ed[i].a];
        ++deg[ed[i].b];
    }

    int q;
    cin >> q;

    for(int i = 0; i < q; ++i)
    {
        cin >> qu[i].t;

        if(qu[i].t == 1)
        {
            cin >> qu[i].a >> qu[i].b >> qu[i].c;
            ++deg[qu[i].a];
            ++deg[qu[i].b];
        }
        else
        {
            cin >> qu[i].a >> qu[i].b;
        }
    }

    int ptr = 0;
    for(int i = 1; i <= n; ++i)
    {
        if(deg[i] >= FAT)
        {
            fat[i] = true;
            num[i] = ptr++;
            fats.push_back(i);
        }
    }

    memset(gfat, -1, sizeof gfat);
    for(int i = 0; i < m; ++i)
    {
        add_edge(ed[i].a, ed[i].b, ed[i].c);
    }

    for(int i = 0; i < q; ++i)
    {
        int a = qu[i].a;
        int b = qu[i].b;

        if(qu[i].t == 1)
        {
            add_edge(a, b, qu[i].c);
        }
        else if(qu[i].t == 2)
        {
            rem_edge(a, b);
        }
        else
        {
            cout << ask_path(a, b) << endl;
        }
    }
}

/* ________ CODE ________ */

int main()
{
#if defined(ANDREIKKAA)
    time_t _start = clock();
#endif
    if (_inpf[0] != '\0') assert(freopen(_inpf, "r", stdin) != nullptr);
    if (_outf[0] != '\0') assert(freopen(_outf, "w", stdout) != nullptr);
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    cout << setprecision(18);
    //cout << fixed;
    mainFunction();
#if defined(ANDREIKKAA)
    cout << "Time: " << (clock() - _start) / (ld)CLOCKS_PER_SEC << endl;
#endif
}
