#include "testlib.h"
#include <bits/stdc++.h>

using namespace std;

// Main limits
int N = (int)1e5;
int M = (int)1e5;
const int NM = (int)1e6;
const int Q = (int)1e5;
const int K = (int)1e9;

// Group 1 limits
const int N1 = (int)1e3;
const int M1 = (int)1e3;

int main(int argc, char* argv[]) {
    registerValidation(argc, argv);

    if (validator.group() == "group1") {
        N = N1;
        M = M1;
    }
    
    int maxType = (validator.group() == "group2" ? 1 : 2);
    
    int n = inf.readInt(1, N, "n");
    inf.readSpace();
    int m = inf.readInt(1, M, "m");
    inf.readSpace();
    int q = inf.readInt(1, Q, "q");
    inf.readSpace();
    int maxscore = inf.readInt(1, K, "k");
    inf.readEoln();

    ensuref(n * 1ll * m <= (long long) NM, "n * m is too large");

    vector<int> a(m);
    for (int i = 0; i < m; i++) {
        a[i] = inf.readInt(0, maxscore, "offline[i]");
        if (i + 1 == m)
            inf.readEoln();
        else
            inf.readSpace();
    }

    vector< vector<int> > b(n, vector<int>(m));
    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++) {
            b[i][j] = inf.readInt(0, maxscore - a[j], "table[i][j]");

            if (j + 1 == m)
                inf.readEoln();
            else
                inf.readSpace();
        }

    set< pair<int, int> > used;

    bool flag = false;
    for (int i = 0; i < q; i++) {
        
        int t = inf.readInt(1, maxType, "type");
        flag = flag || (t == 1);
        inf.readSpace();
        int id = inf.readInt(1, n, "id") - 1;

        if (t == 2) {
            inf.readSpace();
            int task = inf.readInt(1, m, "task") - 1;
            inf.readSpace();
            int ball = inf.readInt(b[id][task], maxscore, "newBall");

            ensuref(used.count({id, task}) == 0, "This combination of userId and taskId was already used");
            ensuref(b[id][task] == maxscore - a[task], "Never ask if online tests not passed");

            used.insert({id, task});
        }

        inf.readEoln();
    }
    
    ensuref(flag, "output should be non-empty");

    inf.readEof();
    return 0;
}
