#include "testlib.h"
#include <vector>

using namespace std;

const int kMinN = 2;
const int kMinM = 1;
const int kMaxN[4] = {100, 100, 1000, 1000};
const int kMaxM[4] = {100, 100, 10 * 1000, 100 * 1000};

vector<vector<int> > graph;
vector<int> used;

void dfs(int u) {
    used[u] = 2;
    for (int i = 0; i < graph[u].size(); i++) {
        ensuref(used[graph[u][i]] != 2, "cycle");
        if (used[graph[u][i]] == 0) {
            dfs(graph[u][i]);
        }
    }
    used[u] = 1;
}

int main(int argc, char* argv[]) {
    registerValidation(argc, argv);
    
	int group = atoi(validator.group().data());
    ensuref(0 <= group && group <= 3, "unknown group id");

    int n = inf.readInt(kMinN, kMaxN[group], "n");
    inf.readSpace();
    int m = inf.readInt(kMinM, kMaxM[group], "m");
    inf.readEoln();
    graph.resize(n);
    used.resize(n);
    for (int i = 0; i < m; i++) {
        int a = inf.readInt(1, n, "a_i");
        inf.readSpace();
        int b = inf.readInt(1, n, "b_i");
        inf.readEoln();
        
        ensuref(a != b, "no self-loops allowed");
        
        graph[a - 1].push_back(b - 1);
    }
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            dfs(i);
        }
    }
    inf.readEof();
}
