#include "testlib.h"
#include <iostream>
#include <vector>

using namespace std;

typedef long long ll;

vector<vector<int> > v;
vector<pair<int, int> > edges;
vector<int> used;
vector<int> order;

int cnt = 0;

void dfs(int u) {
    used[u] = 1;
    for (int i = 0; i < v[u].size(); i++) {
        if (!used[v[u][i]]) {
            dfs(v[u][i]);
        }
    }
    order[u] = cnt++;
}

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);
    
    int n = atoi(argv[1]);
    int m = atoi(argv[2]);
    used.resize(n);
    v.resize(n);
    order.resize(n);
    cout << n << ' ' << m << endl;
    int cnt = 0;
    while (cnt < m) {
        int a = rnd.next(1, n);
        int b = rnd.next(1, n);
        if (a == b) {
            continue;
        }
        v[a - 1].push_back(b - 1);
        v[b - 1].push_back(a - 1);
        edges.push_back(make_pair(a - 1, b - 1));
        cnt++;
    }
    vector<int> tmp(n);
    for (int i = 0; i < n; i++) {
        tmp[i] = i;
    }
    shuffle(tmp.begin(), tmp.end());
    for (int i = 0; i < n; i++) {
        if (!used[tmp[i]]) {
            dfs(tmp[i]);
        }
    }
    shuffle(edges.begin(), edges.end());
    for (int i = 0; i < edges.size(); i++) {
        if (order[edges[i].first] < order[edges[i].second]) {
            swap(edges[i].first, edges[i].second);
        }
        cout << edges[i].first + 1 << ' ' << edges[i].second + 1 << endl;
    }
}
