#include <iostream>
#include <vector>
#include <unordered_set>
#include <stack>

using namespace std;

vector<unordered_set<int>> graph;
vector<bool> used;
stack<int> curPath, path;

int n;

bool dfs(int vert) {
    if (vert == 2 * n + 1) {
        return true;
    }
    used[vert] = 1;
    bool flag = 0;
    for (auto iter = graph[vert].begin(); iter != graph[vert].end(); iter++) {
        if (!used[*iter]) {
            flag = dfs(*iter) || flag;
        }
    }
    return flag;
}

void find_path(int u) {
    used[u] = 1;
    if (u == 2 * n + 1) {
        path = curPath;
        return;
    }
    curPath.push(u);
    for (auto iter = graph[u].begin(); iter != graph[u].end(); iter++) {
        if (!used[*iter]) {
            find_path(*iter);
        }
    }
    curPath.pop();
}

int main() {
    int m;
    cin >> n >> m;
    graph.resize(2 * n + 2);
    used.resize(2 * n + 2);
    for (int i = 1; i <= n; i++) {
        graph[0].insert(i);
        graph[n + i].insert(2 * n + 1);
    }
    bool pathFound = 0;
    int ans = 0;
    dfs(0);
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        if (graph[a].find(b + n) != graph[a].end() || graph[b + n].find(a) != graph[b + n].end()) {
            cout << n - ans << ' ';
            continue;
        }
        graph[a].insert(b + n);
        if (!used[b + n] && used[a]) {
            pathFound = dfs(b + n);
        }
        if (pathFound) {
            used.assign(2 * n + 2, false);
            ans++;
            find_path(0);
            graph[path.top()].erase(2 * n + 1);
            int last = path.top();
            path.pop();
            while (path.size() > 1) {
                graph[path.top()].erase(last);
                graph[last].insert(path.top());
                last = path.top();
                path.pop();
            }
            graph[0].erase(last);
            path.pop();
            used.assign(2 * n + 2, false);
            pathFound = dfs(0);
        }
        cout << n - ans << ' ';
    }
    cout << endl;
}
