#include "testlib.h"
#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <cstdlib>
#include <vector>
#include <set>
#include <map>
#include <cassert>
#include <queue>
#include <ctime>
#include <string>
#include <cstring>
#define mp make_pair
#define pb push_back
#define NAME ""
#define y1 y1_423
#define list lista

using namespace std;

typedef long long ll;
typedef long double ld;

const int nmax = 2000 * 1000;
const ll infl = 1000ll * 1000ll * 1000ll * 1000ll * 1000ll * 1000ll;
const int mod = 1000 * 1000 * 1000 + 7;
const ld pi = acos(-1.0);

struct point {
    ll x, y;
    point(){}
    point(ld X, ld Y) {
        x = X;
        y = Y;
    }
};

point operator + (const point &a, const point &b) { return point(a.x + b.x, a.y + b.y); }
point operator - (const point &a, const point &b) { return point(a.x - b.x, a.y - b.y); }
point operator * (const point &a, ld b) { return point(a.x * b, a.y * b); }
point operator / (const point &a, ld b) { return point(a.x / b, a.y / b); }

ld len(const point &a) { return sqrt(a.x * a.x + a.y * a.y); }
ll scal(const point &a, const point &b) { return a.x * b.x + a.y * b.y; }
ll vect(const point &a, const point &b) { return a.x * b.y - a.y * b.x; }

point turn_l(const point &a) { return point(-a.y, a.x); }
point turn_r(const point &a) { return point(a.y, -a.x); }

int MAXC = -1;

void gen_triangle(point &p1, point &p2, point &p3) {
    p1 = point(rnd.next(-MAXC, MAXC), rnd.next(-MAXC, MAXC));
    p2 = point(rnd.next(-MAXC, MAXC), rnd.next(-MAXC, MAXC));
    p3 = point(rnd.next(-MAXC, MAXC), rnd.next(-MAXC, MAXC));
    while (vect(p2 - p1, p3 - p1) == 0) {
        p3 = point(rnd.next(-MAXC, MAXC), rnd.next(-MAXC, MAXC));
    }
}

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);
    if (argc < 2) {
        cerr << "Usage: n, maxc, randseed" << endl;
        exit(1);
    }
    int n = atoi(argv[1]);
    MAXC = atoi(argv[2]);
    rnd.setSeed(atoi(argv[3]));
    vector<point> ev;
    cout << n << endl;
    for (int i = 0; i < n; i++) {
        point p1 = point(rnd.next(0, 10), rnd.next(0, 10)), p2 = point(rnd.next(MAXC - 10, MAXC - 1), rnd.next(MAXC - 10, MAXC - 1)), p3 = point(p2.x + 1, p2.y);
        p2 = turn_r(p2 - p1), p3 = turn_l(p3 - p1);
        p1 = point(rnd.next(-10, 0), rnd.next(-10, 0));
        cout << p1.x << " " << p1.y << " " << p2.x << " " << p2.y << " " << p3.x << " " << p3.y << endl;
    }
    return 0;
}

