#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <cstdlib>
#include <vector>
#include <set>
#include <map>
#include <cassert>
#include <queue>
#include <ctime>
#include <string>
#include <cstring>
#define mp make_pair
#define pb push_back
#define NAME ""
#define y1 y1_423
#define list lista

using namespace std;

typedef long long ll;
typedef double ld;

const int nmax = 2000 * 1000;
const int inf = 2000 * 1000 * 1000;
const ll infl = 1000ll * 1000ll * 1000ll * 1000ll * 1000ll * 1000ll;
const int mod = 1000 * 1000 * 1000 + 7;
const ld pi = acos(-1.0);

struct point {
    ld x, y;
    point(){}
    point(ld X, ld Y) {
        x = X;
        y = Y;
    }
};

ostream& operator << (ostream& cout, const point &a) {
    return (cout << "(" << a.x << "; " << a.y << ")");
}

template<typename T1, typename T2>
ostream& operator << (ostream& cout, const pair<T1, T2> &a) {
    return cout << "(" << a.first << "; " << a.second << ")";
}

template<typename T>
ostream& operator << (ostream& cout, const vector<T> &a) {
    if (a.size() == 0) {
        return cout << "{}";
    }
    cout << "{" << a[0];
    for (int i = 1; i < (int)a.size(); i++) {
        cout << "; " << a[i];
    }
    return cout << "}";
}


point operator + (const point &a, const point &b) { return point(a.x + b.x, a.y + b.y); }
point operator - (const point &a, const point &b) { return point(a.x - b.x, a.y - b.y); }
point operator * (const point &a, ld b) { return point(a.x * b, a.y * b); }
point operator / (const point &a, ld b) { return point(a.x / b, a.y / b); }

ld len(const point &a) { return sqrt(a.x * a.x + a.y * a.y); }
ld scal(const point &a, const point &b) { return a.x * b.x + a.y * b.y; }
ld vect(const point &a, const point &b) { return a.x * b.y - a.y * b.x; }

point turn_l(const point &a) { return point(-a.y, a.x); }
point turn_r(const point &a) { return point(a.y, -a.x); }

inline bool side(const point &a) {
    return vect(point(1, 0), a) > 0 || (vect(point(1, 0), a) == 0 && scal(point(1, 0), a) > 0);
}

bool operator < (const point &a, const point &b) {
    if (side(a) == side(b)) {
        return vect(a, b) > 0;
    } else {
        return side(a);
    }
}

vector<pair<point, int> > ev;
point p[nmax][3];
int n;

int main() {
    cout.precision(40);
    cin >> n;
    int cnt = 0;
    for (int i = 0; i < n; i++) {
        ll x1, y1, x2, y2, x3, y3;
        scanf("%lld%lld%lld%lld%lld%lld", &x1, &y1, &x2, &y2, &x3, &y3);
        p[i][0] = point(x1, y1);
        p[i][1] = point(x2, y2);
        p[i][2] = point(x3, y3);
        if (vect(p[i][1] - p[i][0], p[i][2] - p[i][0]) < 0) {
            swap(p[i][1], p[i][2]);
        }
        point s1 = turn_r(p[i][1] - p[i][0]);
        point s2 = turn_l(p[i][2] - p[i][0]);
        if (vect(s2, point(1, 0)) > 0 && vect(point(1, 0), s1) >= 0) {
            cnt++;
        }
        cerr << vect(s1, s2) << endl;
        //cerr << "Hop " << vect(s1, s2) << endl;
        ev.pb(mp(s1, 1));
        ev.pb(mp(s2, -1));
    }
    //cout << vect(ev[0].first, ev[1].first) << endl;
    sort(ev.begin(), ev.end());
    //cout << ev << endl;
    int answer = 0;
    for (int i = 0; i < (int)ev.size(); i++) {
        cnt -= ev[i].second;
        assert(cnt >= 0);
        answer = max(answer, cnt);
    }
    cout << answer << endl;
    return 0;
}
